<?php

	if ( strpos($_SERVER['PHP_SELF'],"funcstd.php") !== false ) {
		header( "Location: ../index.php" );
		die;
	}


	function GFEnCrypt( $String ) {
		$return = $String ^ KEY_CRYPT;
		return $return;
	}


	function ismobile() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$is_tabgalaxy = (preg_match('/gt-p7500/i',$user_agent));
		$is_tabgalaxy2 = (preg_match('/gt-p5100/i',$user_agent));
		$is_ipad = (preg_match('/ipad/i',$user_agent));
		$is_iphone = (preg_match('/iphone/i',$user_agent));
		$is_android = (preg_match('/android/i',$user_agent));
		$is_blackberry = (preg_match('/blackberry/i',$user_agent));
		$is_mobile = ( !$is_tabgalaxy and !$is_tabgalaxy2 and ( $is_iphone or $is_android or $is_blackberry ) );
		return $is_mobile;
	}


	function isfirefox() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];
		$is_firefox = (preg_match('/firefox/i',$user_agent));
		return $is_firefox;
	}


	function left( $Str, $Len ) {
		return substr( $Str, 0, $Len );
	}


	function echoPOST() {
		foreach ( $_POST as $key => $value ) {
			echo ( $key . " => " . $value . "<br>" );
		}
		die();
	}


	function String2Ascii( $Str ) {

		$Len_Str = strlen($Str);
		$Return = "";

		for ( $Position = 0; $Position < $Len_Str; $Position++ ) {
			$Return = $Return . str_pad( ord( substr( $Str, $Position, 1 ) ), 3, "0", STR_PAD_LEFT );
		}

		return $Return;

	}

	function CurrentPage() {

		$pageURL = "";

		if ($_SERVER["SERVER_PORT"] != "80") {
			$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"];
		} else {
			$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];
		}

		return $pageURL;
	}


	function DateTime2Time( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,11,5) );
	}


	function DateTime2Date( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,0,10) );
	}


	function DateTime2DTOS( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,0,4) . substr($value,5,2) . substr($value,8,2) );
	}


	function Date2JQueryDate( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,8,2) . '/' . substr($value,5,2) . '/' . substr($value,0,4) );
	}


	function JQueryDate2Date( $value ) {
		if ( !isset($value) OR trim($value) == '' ) {
			return '';
		}
		return ( substr($value,6,4) . '-' . substr($value,3,2) . '-' . substr($value,0,2) );
	}


	function VO2Date( $value ) {
		if ( !isset($value) OR trim($value) == '' ) {
			return '';
		}
		return ( substr($value,0,4) . '-' . substr($value,4,2) . '-' . substr($value,6,2) );
	}


	function VO2DateTime( $date, $time ) {
		if ( !isset($date) OR trim($date) == '' ) {
			return '';
		}
		if ( strlen($time) == 5 ) {
			$time = $time . ':00';
		}
		return ( substr($date,0,4) . '-' . substr($date,4,2) . '-' . substr($date,6,2) . ' ' . $time );
	}


	function RetDayText( $day ) {
		if ( $day == 1 ) {
			return "Senin";
		} elseif ( $day == 2 ) {
			return "Selasa";
		} elseif ( $day == 3 ) {
			return "Rabu";
		} elseif ( $day == 4 ) {
			return "Kamis";
		} elseif ( $day == 5 ) {
			return "Jumat";
		} elseif ( $day == 6 ) {
			return "Sabtu";
		} elseif ( $day == 7 ) {
			return "Minggu";
		}
		return "###";
	}


	function RetDay3Text( $day ) {
		if ( $day == 1 ) {
			return "Sen";
		} elseif ( $day == 2 ) {
			return "Sel";
		} elseif ( $day == 3 ) {
			return "Rab";
		} elseif ( $day == 4 ) {
			return "Kam";
		} elseif ( $day == 5 ) {
			return "Jum";
		} elseif ( $day == 6 ) {
			return "Sab";
		} elseif ( $day == 7 ) {
			return "Min";
		}
		return "###";
	}


	function RetMonthText( $month ) {
		if ( $month == 1 ) {
			return "Januari";
		} elseif ( $month == 2 ) {
			return "Februari";
		} elseif ( $month == 3 ) {
			return "Maret";
		} elseif ( $month == 4 ) {
			return "April";
		} elseif ( $month == 5 ) {
			return "Mei";
		} elseif ( $month == 6 ) {
			return "Juni";
		} elseif ( $month == 7 ) {
			return "Juli";
		} elseif ( $month == 8 ) {
			return "Agustus";
		} elseif ( $month == 9 ) {
			return "September";
		} elseif ( $month == 10 ) {
			return "Oktober";
		} elseif ( $month == 11 ) {
			return "Nopember";
		} elseif ( $month == 12 ) {
			return "Desember";
		}
		return "###";
	}


	function RetMonth3Text( $month ) {
		if ( $month == 1 ) {
			return "Jan";
		} elseif ( $month == 2 ) {
			return "Feb";
		} elseif ( $month == 3 ) {
			return "Mar";
		} elseif ( $month == 4 ) {
			return "Apr";
		} elseif ( $month == 5 ) {
			return "Mei";
		} elseif ( $month == 6 ) {
			return "Jun";
		} elseif ( $month == 7 ) {
			return "Jul";
		} elseif ( $month == 8 ) {
			return "Agt";
		} elseif ( $month == 9 ) {
			return "Sep";
		} elseif ( $month == 10 ) {
			return "Okt";
		} elseif ( $month == 11 ) {
			return "Nop";
		} elseif ( $month == 12 ) {
			return "Des";
		}
		return "###";
	}


	function Date2mmmyyyy( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( RetMonth3Text(substr($value,5,2)) . ' ' . substr($value,0,4) );
	}


	function Date2ddmmmyyyy( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,8,2) . ' ' . RetMonth3Text(substr($value,5,2)) . ' ' . substr($value,0,4) );
	}


	function Date2ddmmmmyyyy( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( substr($value,8,2) . ' ' . RetMonthText(substr($value,5,2)) . ' ' . substr($value,0,4) );
	}


	function Date2dayddmmmyyyy( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		$day = intval(substr($value,8,2));
		$month = intval(substr($value,5,2));
		$year = intval(substr($value,0,4));
		$date = mktime( 0, 0, 0, $month, $day, $year );
		$weekday = date('N',$date);
		return ( RetDay3Text($weekday) . ', ' . Date2ddmmmyyyy($value) );
	}

	
	function Date2dayddmmmmyyyy( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		$day = intval(substr($value,8,2));
		$month = intval(substr($value,5,2));
		$year = intval(substr($value,0,4));
		$date = mktime( 0, 0, 0, $month, $day, $year );
		$weekday = date('N',$date);
		return ( RetDayText($weekday) . ', ' . Date2ddmmmmyyyy($value) );
	}


	function DateTime2FullText( $value ) {
		if ( !isset($value) OR trim($value) == '' OR $value == '0000-00-00 00:00:00' ) {
			return '';
		}
		return ( Date2ddmmmyyyy($value) . '  ' . DateTime2Time($value) );
	}


	function yyyymmdd2ddmmmyyyy( $value ) {
		// YYYYMMDD to ddMMMyyyy ....
		if ( !isset($value) OR trim($value) == '' OR $value == '00000000' OR strlen($value) != 8 ) {
			return '';
		}
		return ( substr($value,6,2) . ' ' . RetMonth3Text(substr($value,4,2)) . ' ' . substr($value,0,4) );
	}


	function CalcAge( $birthdate ) {

		if ( !isset($birthdate) OR trim($birthdate) == '' OR $birthdate == '0000-00-00' ) {
			return 0;
		}

		list( $year, $month, $day ) = explode( "-", $birthdate );

		$year_diff = date("Y") - $year;
		$month_diff = date("m") - $month;
		$day_diff = date("d") - $day;

		if ( $month_diff < 0 ) {
			$year_diff = $year_diff - 1;
		} elseif ( ( $month_diff == 0 ) AND ( $day_diff < 0 ) ) {
			$year_diff = $year_diff - 1;
		}

		return $year_diff;
	}


	function ShowNumber( $value ) {
		if ( $value == 0 ) {
			return "-";
		}
		return $value;
	}


	function ShowFormatDigitNumber( $value ) {
		if ( $value == 0 ) {
			return "-";
		}
		return number_format( $value, 2, ',', '.' );
	}


	function RetRandomNumber( $jmlchar ) {
		$random = "";
		for ( $x = 1; $x <= $jmlchar; $x++ ) {
			$random = $random . rand(0,9);
		}
		return $random;
	}


	function GetCookies( $sesi ) {
		if ( isset( $_COOKIE[$sesi] ) ) {
			return $_COOKIE[$sesi];
		}
		return "";
	}


	function makeClickableLinks($string) {
		// Email
//		$string = preg_replace("/([\w-?&;#~=\.\/]+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?))/i","<a href=\"mailto:$1\">$1</a>", $string);  22 Okt 2020 error pada PHP 7.3, gak tau kenapa ...
		$search = array('/<p>__<\/p>/', '/([a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4})/');
		$replace = array('<hr />', '<a href="mailto:$1">$1</a>');
		$string = preg_replace( $search, $replace, $string );
		// Youtube
		$string = preg_replace("/\s*[a-zA-Z\/\/:\.]*youtube.com\/watch\?v=([a-zA-Z0-9\-_]+)([a-zA-Z0-9\/\*\-\_\?\&\;\%\=\.]*)/i"," <object width=\"100%\" height=\"344\"><param name=\"movie\" value=\"http://www.youtube.com/v/$1&hl=en&fs=1\"></param><param name=\"allowFullScreen\" value=\"true\"></param><embed src=\"http://www.youtube.com/v/$1&hl=en&fs=1\" type=\"application/x-shockwave-flash\" allowfullscreen=\"true\" width=\"100%\" height=\"450\"></embed></object>  ",$string);
		// Links
		$string = preg_replace("#(^|[\n\s>])([\w]+?://[^\s\"\n\r\t<]*)#is", "\\1<a href=\"\\2\" target=_blank>\\2</a>", $string);
		return $string;
	}


	function replaceSpaceHTML($string) {
		$string = str_replace( "  ", "&nbsp;&nbsp;", $string );
		return $string;
	}


	function replaceEnterWith($string,$with) {
		// Kalau nl2br() Enter menjadi <br> ...
		$remove = array("\n", "\r\n", "\n\r", "\r");
		$string = str_replace( $remove, $with, $string );
		return $string;
	}


	function string2SQL($string) {
		$string = str_replace( "\\", "\\\\", $string );
		$string = str_replace( "'", "\'", $string );
		//$string = addslashes($string);
		return "'" . $string . "'";
	}


	function trimLastbr($string) {
		while ( substr( $string, strlen($string) - 4, 4 ) == "<br>" ) {
			$string = substr( $string, 0, strlen($string) - 4 );
		}
		return $string;
	}


	function ReturnAsc( $value ) {

		$return = "";

		for ( $x = 0; $x < strlen($value); $x++ ) {
			$return = $return . strval(ord(substr($value,$x,1))) . ",";
		}

		return $return;
	}


	function JQueryDate2DateStr( $value ) {
		if ( !isset($value) OR trim($value) == '' ) {
			return '';
		}
		return ( substr($value,6,4) . substr($value,3,2) . substr($value,0,2) );
	}


	function JQueryDateBox2DateStr( $value ) {
		if ( !isset($value) OR trim($value) == '' ) {
			return '';
		}
		return ( substr($value,0,4) . substr($value,5,2) . substr($value,8,2) );
	}

?>